import unittest
import pandas as pd
import player as espn
from utils import calculate_age

class test(unittest.TestCase):

    def test_patrick_mahomes(self):

        mahomes = espn.Player('Patrick', 'Mahomes', 3139477, 'QB')

        for season in [2019, 2020, 2021, 2022, 2023]:
            mahomes.Set_Season(season)
            mahomes.Set_Game_Log()

        actual_mahomes = mahomes.Get_Game_Log()

        data = [['Mahomes', 'Patrick', pd.Timestamp('2019-12-29 00:00:00'), 24.28, 'vsLAC', 'W31-21', '16', '25', '174', '64.0', '7.0', '1', '1', '47', '0', '81.1', '61.7', '7', '21', '3.0', '0', '11'],
                ['Mahomes', 'Patrick', pd.Timestamp('2019-12-22 00:00:00'), 24.26, '@CHI', 'W26-3', '23', '33', '251', '69.7', '7.6', '2', '0', '19', '1', '112.1', '89.3', '2', '14', '7.0', '1', '12'],
                ['Mahomes', 'Patrick', pd.Timestamp('2019-12-15 00:00:00'), 24.24, 'vsDEN', 'W23-3', '27', '34', '340', '79.4', '10.0', '2', '1', '41', '3', '115.7', '91.4', '3', '11', '3.7', '0', '7'],
                ['Mahomes', 'Patrick', pd.Timestamp('2019-12-08 00:00:00'), 24.22, '@NE', 'W23-16', '26', '40', '283', '65.0', '7.1', '1', '1', '48', '1', '83.6', '59.1', '6', '6', '1.0', '0', '5'],
                ['Mahomes', 'Patrick', pd.Timestamp('2019-12-01 00:00:00'), 24.21, 'vsOAK', 'W40-9', '15', '29', '175', '51.7', '6.0', '1', '0', '47', '1', '81.8', '71.2', '3', '25', '8.3', '1', '13'],
                ['Mahomes', 'Patrick', pd.Timestamp('2019-11-18 00:00:00'), 24.17, 'vsLAC', 'W24-17', '19', '32', '182', '59.4', '5.7', '1', '1', '31', '1', '72.7', '62.5', '5', '59', '11.8', '0', '24'],
                ['Mahomes', 'Patrick', pd.Timestamp('2019-11-10 00:00:00'), 24.15, '@TEN', 'L35-32', '36', '50', '446', '72.0', '8.9', '3', '0', '63', '2', '119.3', '84.3', '0', '0', '0.0', '0', '0'],
                ['Mahomes', 'Patrick', pd.Timestamp('2019-10-17 00:00:00'), 24.08, '@DEN', 'W30-6', '10', '11', '76', '90.9', '6.9', '1', '0', '21', '0', '125.8', '94.3', '1', '2', '2.0', '0', '2'],
                ['Mahomes', 'Patrick', pd.Timestamp('2019-10-13 00:00:00'), 24.07, 'vsHOU', 'L31-24', '19', '35', '273', '54.3', '7.8', '3', '1', '52', '1', '96.5', '56.0', '1', '-1', '-1.0', '0', '-1'],
                ['Mahomes', 'Patrick', pd.Timestamp('2019-10-06 00:00:00'), 24.05, 'vsIND', 'L19-13', '22', '39', '321', '56.4', '8.2', '1', '0', '31', '4', '91.9', '52.6', '3', '17', '5.7', '0', '14'],
                ['Mahomes', 'Patrick', pd.Timestamp('2019-09-29 00:00:00'), 24.03, '@DET', 'W34-30', '24', '42', '315', '57.1', '7.5', '0', '0', '33', '0', '81.0', '68.5', '6', '54', '9.0', '0', '25'],
                ['Mahomes', 'Patrick', pd.Timestamp('2019-09-22 00:00:00'), 24.01, 'vsBAL', 'W33-28', '27', '37', '374', '73.0', '10.1', '3', '0', '83', '1', '132.0', '86.5', '4', '9', '2.3', '0', '11'],
                ['Mahomes', 'Patrick', pd.Timestamp('2019-09-15 00:00:00'), 23.99, '@OAK', 'W28-10', '30', '44', '443', '68.2', '10.1', '4', '0', '44', '2', '131.2', '95.0', '1', '-1', '-1.0', '0', '-1'],
                ['Mahomes', 'Patrick', pd.Timestamp('2019-09-08 00:00:00'), 23.98, '@JAX', 'W40-26', '25', '33', '378', '75.8', '11.5', '3', '0', '68', '0', '143.2', '91.4', '1', '2', '2.0', '0', '2'],
                ['Mahomes', 'Patrick', pd.Timestamp('2020-12-27 00:00:00'), 25.28, 'vsATL', 'W17-14', '24', '44', '278', '54.5', '6.3', '2', '1', '31', '0', '79.5', '60.4', '3', '21', '7.0', '0', '13'],
                ['Mahomes', 'Patrick', pd.Timestamp('2020-12-20 00:00:00'), 25.26, '@NO', 'W32-29', '26', '47', '254', '55.3', '5.4', '3', '0', '23', '4', '92.0', '68.7', '7', '37', '5.3', '0', '24'],
                ['Mahomes', 'Patrick', pd.Timestamp('2020-12-13 00:00:00'), 25.24, '@MIA', 'W33-27', '24', '34', '393', '70.6', '11.6', '2', '3', '44', '3', '91.9', '61.5', '5', '9', '1.8', '0', '6'],
                ['Mahomes', 'Patrick', pd.Timestamp('2020-12-06 00:00:00'), 25.22, 'vsDEN', 'W22-16', '25', '40', '318', '62.5', '8.0', '1', '0', '30', '1', '95.6', '75.2', '4', '26', '6.5', '0', '20'],
                ['Mahomes', 'Patrick', pd.Timestamp('2020-11-29 00:00:00'), 25.2, '@TB', 'W27-24', '37', '49', '462', '75.5', '9.4', '3', '0', '75', '2', '124.7', '88.7', '4', '28', '7.0', '0', '17'],
                ['Mahomes', 'Patrick', pd.Timestamp('2020-11-22 00:00:00'), 25.18, '@LV', 'W35-31', '34', '45', '348', '75.6', '7.7', '2', '1', '22', '0', '102.8', '86.5', '4', '16', '4.0', '0', '11'],
                ['Mahomes', 'Patrick', pd.Timestamp('2020-11-08 00:00:00'), 25.14, 'vsCAR', 'W33-31', '30', '45', '372', '66.7', '8.3', '4', '0', '44', '2', '121.7', '76.4', '1', '6', '6.0', '0', '6'],
                ['Mahomes', 'Patrick', pd.Timestamp('2020-11-01 00:00:00'), 25.12, 'vsNYJ', 'W35-9', '31', '42', '416', '73.8', '9.9', '5', '0', '41', '0', '144.4', '88.5', '0', '0', '0.0', '0', '0'],
                ['Mahomes', 'Patrick', pd.Timestamp('2020-10-25 00:00:00'), 25.1, '@DEN', 'W43-16', '15', '23', '200', '65.2', '8.7', '1', '0', '38', '3', '107.2', '37.4', '0', '0', '0.0', '0', '0'],
                ['Mahomes', 'Patrick', pd.Timestamp('2020-10-19 00:00:00'), 25.09, '@BUF', 'W26-17', '21', '26', '225', '80.8', '8.7', '2', '0', '37', '1', '128.4', '81.7', '10', '36', '3.6', '0', '9'],
                ['Mahomes', 'Patrick', pd.Timestamp('2020-10-11 00:00:00'), 25.07, 'vsLV', 'L40-32', '22', '43', '340', '51.2', '7.9', '2', '1', '37', '3', '83.5', '63.4', '6', '21', '3.5', '1', '6'],
                ['Mahomes', 'Patrick', pd.Timestamp('2020-10-05 00:00:00'), 25.05, 'vsNE', 'W26-10', '19', '29', '236', '65.5', '8.1', '2', '0', '45', '1', '113.6', '47.8', '8', '28', '3.5', '0', '18'],
                ['Mahomes', 'Patrick', pd.Timestamp('2020-09-28 00:00:00'), 25.03, '@BAL', 'W34-20', '31', '42', '385', '73.8', '9.2', '4', '0', '49', '0', '133.5', '98.0', '4', '26', '6.5', '1', '12'],
                ['Mahomes', 'Patrick', pd.Timestamp('2020-09-20 00:00:00'), 25.01, '@LAC', 'W23-20 OT', '27', '47', '302', '57.4', '6.4', '2', '0', '54', '1', '90.9', '79.2', '6', '54', '9.0', '0', '21'],
                ['Mahomes', 'Patrick', pd.Timestamp('2020-09-10 00:00:00'), 24.98, 'vsHOU', 'W34-20', '24', '32', '211', '75.0', '6.6', '3', '0', '19', '1', '123.3', '80.7', '0', '0', '0.0', '0', '0'],
                ['Mahomes', 'Patrick', pd.Timestamp('2022-01-08 00:00:00'), 26.31, '@DEN', 'W28-24', '27', '44', '270', '61.4', '6.1', '2', '0', '44', '1', '93.9', '75.1', '9', '54', '6.0', '0', '25'],
                ['Mahomes', 'Patrick', pd.Timestamp('2022-01-02 00:00:00'), 26.29, '@CIN', 'L34-31', '26', '35', '259', '74.3', '7.4', '2', '0', '53', '0', '113.9', '89.6', '2', '25', '12.5', '0', '17'],
                ['Mahomes', 'Patrick', pd.Timestamp('2021-12-26 00:00:00'), 26.27, 'vsPIT', 'W36-10', '23', '30', '258', '76.7', '8.6', '3', '0', '50', '2', '135.1', '81.0', '0', '0', '0.0', '0', '0'],
                ['Mahomes', 'Patrick', pd.Timestamp('2021-12-16 00:00:00'), 26.25, '@LAC', 'W34-28 OT', '31', '47', '410', '66.0', '8.7', '3', '1', '69', '1', '105.8', '79.1', '3', '32', '10.7', '0', '32'],
                ['Mahomes', 'Patrick', pd.Timestamp('2021-12-12 00:00:00'), 26.24, 'vsLV', 'W48-9', '20', '24', '258', '83.3', '10.8', '2', '0', '44', '3', '139.2', '71.8', '4', '20', '5.0', '0', '10'],
                ['Mahomes', 'Patrick', pd.Timestamp('2021-12-05 00:00:00'), 26.22, 'vsDEN', 'W22-9', '15', '29', '184', '51.7', '6.3', '0', '1', '38', '1', '57.3', '44.9', '4', '12', '3.0', '1', '10'],
                ['Mahomes', 'Patrick', pd.Timestamp('2021-11-21 00:00:00'), 26.18, 'vsDAL', 'W19-9', '23', '37', '260', '62.2', '7.0', '0', '1', '37', '3', '71.9', '51.0', '7', '11', '1.6', '0', '11'],
                ['Mahomes', 'Patrick', pd.Timestamp('2021-11-14 00:00:00'), 26.16, '@LV', 'W41-14', '35', '50', '406', '70.0', '8.1', '5', '0', '38', '0', '127.6', '84.0', '0', '0', '0.0', '0', '0'],
                ['Mahomes', 'Patrick', pd.Timestamp('2021-11-07 00:00:00'), 26.14, 'vsGB', 'W13-7', '20', '37', '166', '54.1', '4.5', '1', '0', '25', '1', '74.8', '48.2', '2', '-2', '-1.0', '0', '-1'],
                ['Mahomes', 'Patrick', pd.Timestamp('2021-11-01 00:00:00'), 26.12, 'vsNYG', 'W20-17', '29', '48', '275', '60.4', '5.7', '1', '1', '24', '2', '74.6', '24.5', '3', '10', '3.3', '0', '6'],
                ['Mahomes', 'Patrick', pd.Timestamp('2021-10-24 00:00:00'), 26.1, '@TEN', 'L27-3', '20', '35', '206', '57.1', '5.9', '0', '1', '25', '4', '62.3', '9.9', '6', '35', '5.8', '0', '13'],
                ['Mahomes', 'Patrick', pd.Timestamp('2021-10-17 00:00:00'), 26.08, '@WSH', 'W31-13', '32', '47', '397', '68.1', '8.4', '2', '2', '49', '3', '90.5', '57.4', '3', '31', '10.3', '0', '17'],
                ['Mahomes', 'Patrick', pd.Timestamp('2021-10-10 00:00:00'), 26.06, 'vsBUF', 'L38-20', '33', '54', '272', '61.1', '5.0', '2', '2', '26', '2', '70.9', '49.0', '8', '61', '7.6', '0', '23'],
                ['Mahomes', 'Patrick', pd.Timestamp('2021-10-03 00:00:00'), 26.04, '@PHI', 'W42-30', '24', '30', '278', '80.0', '9.3', '5', '1', '44', '1', '131.0', '92.4', '5', '26', '5.2', '0', '12'],
                ['Mahomes', 'Patrick', pd.Timestamp('2021-09-26 00:00:00'), 26.02, 'vsLAC', 'L30-24', '27', '44', '260', '61.4', '5.9', '3', '2', '28', '2', '81.6', '61.4', '4', '45', '11.3', '0', '21'],
                ['Mahomes', 'Patrick', pd.Timestamp('2021-09-19 00:00:00'), 26.01, '@BAL', 'L36-35', '24', '31', '343', '77.4', '11.1', '3', '1', '46', '0', '131.5', '77.6', '1', '3', '3.0', '0', '3'],
                ['Mahomes', 'Patrick', pd.Timestamp('2021-09-12 00:00:00'), 25.99, 'vsCLE', 'W33-29', '27', '36', '337', '75.0', '9.4', '3', '0', '75', '2', '131.4', '92.9', '5', '18', '3.6', '1', '8'],
                ['Mahomes', 'Patrick', pd.Timestamp('2023-01-07 00:00:00'), 27.31, '@LV', 'W31-13', '18', '26', '202', '69.2', '7.8', '1', '0', '67', '2', '105.0', '82.9', '3', '29', '9.7', '0', '14'],
                ['Mahomes', 'Patrick', pd.Timestamp('2023-01-01 00:00:00'), 27.29, 'vsDEN', 'W27-24', '29', '42', '328', '69.1', '7.8', '3', '1', '38', '0', '106.1', '67.2', '4', '8', '2.0', '0', '4'],
                ['Mahomes', 'Patrick', pd.Timestamp('2022-12-24 00:00:00'), 27.27, 'vsSEA', 'W24-10', '16', '28', '224', '57.1', '8.0', '2', '0', '52', '1', '106.8', '37.6', '2', '8', '4.0', '1', '5'],
                ['Mahomes', 'Patrick', pd.Timestamp('2022-12-18 00:00:00'), 27.25, '@HOU', 'W30-24 OT', '36', '41', '336', '87.8', '8.2', '2', '0', '21', '2', '117.1', '93.5', '5', '33', '6.6', '1', '14'],
                ['Mahomes', 'Patrick', pd.Timestamp('2022-12-11 00:00:00'), 27.23, '@DEN', 'W34-28', '28', '42', '352', '66.7', '8.4', '3', '3', '56', '2', '86.6', '66.9', '3', '-3', '-1.0', '0', '-1'],
                ['Mahomes', 'Patrick', pd.Timestamp('2022-12-04 00:00:00'), 27.21, '@CIN', 'L27-24', '16', '27', '223', '59.3', '8.3', '1', '0', '42', '2', '98.2', '91.5', '2', '9', '4.5', '1', '6'],
                ['Mahomes', 'Patrick', pd.Timestamp('2022-11-27 00:00:00'), 27.19, 'vsLAR', 'W26-10', '27', '42', '320', '64.3', '7.6', '1', '1', '39', '0', '85.4', '69.6', '4', '36', '9.0', '0', '13'],
                ['Mahomes', 'Patrick', pd.Timestamp('2022-11-20 00:00:00'), 27.18, '@LAC', 'W30-27', '20', '34', '329', '58.8', '9.7', '3', '0', '40', '1', '120.8', '82.4', '4', '23', '5.8', '0', '16'],
                ['Mahomes', 'Patrick', pd.Timestamp('2022-11-13 00:00:00'), 27.16, 'vsJAX', 'W27-17', '26', '35', '331', '74.3', '9.5', '4', '1', '46', '0', '129.6', '93.4', '7', '39', '5.6', '0', '19'],
                ['Mahomes', 'Patrick', pd.Timestamp('2022-11-06 00:00:00'), 27.14, 'vsTEN', 'W20-17 OT', '43', '68', '446', '63.2', '6.6', '1', '1', '33', '4', '80.9', '72.7', '6', '63', '10.5', '1', '20'],
                ['Mahomes', 'Patrick', pd.Timestamp('2022-10-23 00:00:00'), 27.1, '@SF', 'W44-23', '25', '34', '423', '73.5', '12.4', '3', '1', '57', '1', '132.4', '91.9', '0', '0', '0.0', '0', '0'],
                ['Mahomes', 'Patrick', pd.Timestamp('2022-10-16 00:00:00'), 27.08, 'vsBUF', 'L24-20', '25', '40', '338', '62.5', '8.5', '2', '2', '42', '3', '85.2', '58.0', '4', '21', '5.3', '0', '10'],
                ['Mahomes', 'Patrick', pd.Timestamp('2022-10-10 00:00:00'), 27.06, 'vsLV', 'W30-29', '29', '43', '292', '67.4', '6.8', '4', '0', '36', '3', '117.6', '65.5', '4', '28', '7.0', '0', '16'],
                ['Mahomes', 'Patrick', pd.Timestamp('2022-10-02 00:00:00'), 27.04, '@TB', 'W41-31', '23', '37', '249', '62.2', '6.7', '3', '1', '36', '3', '97.7', '90.6', '4', '34', '8.5', '0', '11'],
                ['Mahomes', 'Patrick', pd.Timestamp('2022-09-25 00:00:00'), 27.02, '@IND', 'L20-17', '20', '35', '262', '57.1', '7.5', '1', '1', '53', '1', '78.5', '71.8', '4', '26', '6.5', '0', '10'],
                ['Mahomes', 'Patrick', pd.Timestamp('2022-09-15 00:00:00'), 26.99, 'vsLAC', 'W27-24', '24', '35', '235', '68.6', '6.7', '2', '0', '41', '1', '106.2', '66.6', '2', '-1', '-0.5', '0', '0'],
                ['Mahomes', 'Patrick', pd.Timestamp('2022-09-11 00:00:00'), 26.98, '@ARI', 'W44-21', '30', '39', '360', '76.9', '9.2', '5', '0', '35', '0', '144.2', '94.9', '3', '5', '1.7', '0', '4'],
                ['Mahomes', 'Patrick', pd.Timestamp('2023-12-31 00:00:00'), 28.29, 'vsCIN', 'W25-17', '21', '29', '245', '72.4', '8.4', '1', '0', '67', '2', '109.1', '52.8', '4', '2', '0.5', '0', '2'],
                ['Mahomes', 'Patrick', pd.Timestamp('2023-12-25 00:00:00'), 28.27, 'vsLV', 'L20-14', '27', '44', '235', '61.4', '5.3', '1', '1', '45', '4', '73.6', '32.3', '10', '53', '5.3', '0', '13'],
                ['Mahomes', 'Patrick', pd.Timestamp('2023-12-17 00:00:00'), 28.25, '@NE', 'W27-17', '27', '37', '305', '73.0', '8.2', '2', '2', '48', '3', '92.7', '65.7', '3', '-5', '-1.7', '0', '-1'],
                ['Mahomes', 'Patrick', pd.Timestamp('2023-12-10 00:00:00'), 28.23, 'vsBUF', 'L20-17', '25', '43', '271', '58.1', '6.3', '1', '1', '23', '1', '74.9', '28.9', '1', '8', '8.0', '0', '8'],
                ['Mahomes', 'Patrick', pd.Timestamp('2023-12-03 00:00:00'), 28.21, '@GB', 'L27-19', '21', '33', '210', '63.6', '6.4', '1', '1', '27', '3', '79.1', '52.2', '4', '26', '6.5', '0', '10'],
                ['Mahomes', 'Patrick', pd.Timestamp('2023-11-26 00:00:00'), 28.19, '@LV', 'W31-17', '27', '34', '298', '79.4', '8.8', '2', '0', '39', '1', '122.8', '83.7', '5', '9', '1.8', '0', '7'],
                ['Mahomes', 'Patrick', pd.Timestamp('2023-11-20 00:00:00'), 28.18, 'vsPHI', 'L21-17', '24', '43', '177', '55.8', '4.1', '2', '1', '17', '1', '71.6', '36.9', '6', '38', '6.3', '0', '14'],
                ['Mahomes', 'Patrick', pd.Timestamp('2023-11-05 00:00:00'), 28.13, 'vsMIA', 'W21-14', '20', '30', '185', '66.7', '6.2', '2', '0', '25', '2', '105.6', '49.2', '6', '24', '4.0', '0', '16'],
                ['Mahomes', 'Patrick', pd.Timestamp('2023-10-29 00:00:00'), 28.12, '@DEN', 'L24-9', '24', '38', '240', '63.2', '6.3', '0', '2', '39', '3', '59.1', '51.3', '3', '20', '6.7', '0', '8'],
                ['Mahomes', 'Patrick', pd.Timestamp('2023-10-22 00:00:00'), 28.1, 'vsLAC', 'W31-17', '32', '42', '424', '76.2', '10.1', '4', '1', '53', '1', '129.5', '93.9', '4', '29', '7.3', '0', '23'],
                ['Mahomes', 'Patrick', pd.Timestamp('2023-10-12 00:00:00'), 28.07, 'vsDEN', 'W19-8', '30', '40', '306', '75.0', '7.7', '1', '1', '40', '2', '94.4', '66.0', '6', '31', '5.2', '0', '15'],
                ['Mahomes', 'Patrick', pd.Timestamp('2023-10-08 00:00:00'), 28.06, '@MIN', 'W27-20', '31', '41', '281', '75.6', '6.9', '2', '0', '33', '2', '109.9', '83.6', '0', '0', '0.0', '0', '0'],
                ['Mahomes', 'Patrick', pd.Timestamp('2023-10-01 00:00:00'), 28.04, '@NYJ', 'W23-20', '18', '30', '203', '60.0', '6.8', '1', '2', '34', '1', '63.6', '81.8', '7', '51', '7.3', '0', '25'],
                ['Mahomes', 'Patrick', pd.Timestamp('2023-09-24 00:00:00'), 28.02, 'vsCHI', 'W41-10', '24', '33', '272', '72.7', '8.2', '3', '0', '37', '0', '127.3', '86.3', '3', '28', '9.3', '0', '15'],
                ['Mahomes', 'Patrick', pd.Timestamp('2023-09-17 00:00:00'), 28.0, '@JAX', 'W17-9', '29', '41', '305', '70.7', '7.4', '2', '1', '54', '1', '98.1', '71.8', '7', '30', '4.3', '0', '14'],
                ['Mahomes', 'Patrick', pd.Timestamp('2023-09-07 00:00:00'), 27.97, 'vsDET', 'L21-20', '21', '39', '226', '53.9', '5.8', '2', '1', '34', '0', '77.5', '66.9', '6', '45', '7.5', '0', '16']]
        expected_mahomes = pd.DataFrame(data, columns=['LAST', 'FIRST', 'GAME_DT', 'AGE', 'OPP', 'RESULT', 'CMP', 'ATT', 'PASS_YDS', 'CMP%', 'PASS_AVG', 'PASS_TD', 'INT', 'PASS_LNG', 'SACK', 'RTG', 'QBR', 'CAR', 'RUSH_YDS', 'RUSH_AVG', 'RUSH_TD', 'RUSH_LNG'])
        expected_mahomes = expected_mahomes.sort_values(by='GAME_DT')
        expected_mahomes = expected_mahomes.reset_index(drop=True)

        self.assertTrue(actual_mahomes.equals(expected_mahomes))

    def test_christian_mccaffrey(self):

        cmc = espn.Player('Christian', 'McCaffrey', 3117251, 'RB')

        for season in [2019, 2020, 2021, 2022, 2023]:
            cmc.Set_Season(season)
            cmc.Set_Game_Log()

        actual_cmc = cmc.Get_Game_Log()

        data = [['McCaffrey', 'Christian', pd.Timestamp('2019-12-29 00:00:00'), 23.56, 'vsNO', 'L42-10', '9', '26', '2.9', '1', '10', '7', '10', '72', '10.3', '0', '28', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2019-12-22 00:00:00'), 23.54, '@IND', 'L38-6', '13', '54', '4.2', '0', '14', '15', '15', '119', '7.9', '0', '13', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2019-12-15 00:00:00'), 23.52, 'vsSEA', 'L30-24', '19', '87', '4.6', '2', '15', '8', '10', '88', '11.0', '0', '18', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2019-12-08 00:00:00'), 23.5, '@ATL', 'L40-20', '11', '53', '4.8', '0', '11', '11', '12', '82', '7.5', '0', '13', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2019-12-01 00:00:00'), 23.48, 'vsWSH', 'L29-21', '14', '44', '3.1', '0', '12', '7', '12', '58', '8.3', '0', '15', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2019-11-24 00:00:00'), 23.47, '@NO', 'L34-31', '22', '64', '2.9', '1', '9', '9', '9', '69', '7.7', '1', '23', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2019-11-17 00:00:00'), 23.45, 'vsATL', 'L29-3', '14', '70', '5.0', '0', '18', '11', '15', '121', '11.0', '0', '23', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2019-11-10 00:00:00'), 23.43, '@GB', 'L24-16', '20', '108', '5.4', '1', '18', '6', '7', '33', '5.5', '0', '11', '1', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2019-11-03 00:00:00'), 23.41, 'vsTEN', 'W30-20', '24', '146', '6.1', '2', '58', '3', '3', '20', '6.7', '1', '10', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2019-10-27 00:00:00'), 23.39, '@SF', 'L51-13', '14', '117', '8.4', '1', '40', '4', '5', '38', '9.5', '0', '24', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2019-10-13 00:00:00'), 23.35, 'vsTB', 'W37-26', '22', '31', '1.4', '1', '10', '4', '5', '26', '6.5', '1', '25', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2019-10-06 00:00:00'), 23.33, 'vsJAX', 'W34-27', '19', '176', '9.3', '2', '84', '6', '8', '61', '10.2', '1', '18', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2019-09-29 00:00:00'), 23.31, '@HOU', 'W16-10', '27', '93', '3.4', '1', '13', '10', '10', '86', '8.6', '0', '21', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2019-09-22 00:00:00'), 23.29, '@ARI', 'W38-20', '24', '153', '6.4', '1', '76', '3', '4', '35', '11.7', '0', '18', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2019-09-12 00:00:00'), 23.27, 'vsTB', 'L20-14', '16', '37', '2.3', '0', '10', '2', '6', '16', '8.0', '0', '10', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2019-09-08 00:00:00'), 23.25, 'vsLAR', 'L30-27', '19', '128', '6.7', '2', '23', '10', '11', '81', '8.1', '0', '17', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2020-11-08 00:00:00'), 24.42, '@KC', 'L33-31', '18', '69', '3.8', '1', '13', '10', '10', '82', '8.2', '1', '24', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2020-09-20 00:00:00'), 24.29, '@TB', 'L31-17', '18', '59', '3.3', '2', '9', '4', '5', '29', '7.3', '0', '10', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2020-09-13 00:00:00'), 24.27, 'vsLV', 'L34-30', '23', '97', '4.2', '2', '15', '3', '4', '38', '12.7', '0', '16', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2021-11-28 00:00:00'), 25.48, '@MIA', 'L33-10', '10', '35', '3.5', '0', '15', '0', '1', '0', '0.0', '0', '0', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2021-11-21 00:00:00'), 25.46, 'vsWSH', 'L27-21', '10', '59', '5.9', '0', '15', '7', '8', '60', '8.6', '1', '27', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2021-11-14 00:00:00'), 25.44, '@ARI', 'W34-10', '13', '95', '7.3', '0', '15', '10', '10', '66', '6.6', '0', '15', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2021-11-07 00:00:00'), 25.42, 'vsNE', 'L24-6', '14', '52', '3.7', '0', '10', '4', '5', '54', '13.5', '0', '21', '1', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2021-09-23 00:00:00'), 25.3, '@HOU', 'W24-9', '7', '31', '4.4', '0', '10', '2', '2', '9', '4.5', '0', '8', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2021-09-19 00:00:00'), 25.28, 'vsNO', 'W26-7', '24', '72', '3.0', '1', '16', '5', '6', '65', '13.0', '0', '32', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2021-09-12 00:00:00'), 25.27, 'vsNYJ', 'W19-14', '21', '98', '4.7', '0', '18', '9', '9', '89', '9.9', '0', '22', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2023-01-08 00:00:00'), 26.59, 'vsARI', 'W38-13', '10', '45', '4.5', '0', '19', '3', '3', '34', '11.3', '1', '21', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2023-01-01 00:00:00'), 26.57, '@LV', 'W37-34 OT', '19', '121', '6.4', '1', '37', '6', '9', '72', '12.0', '0', '38', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2022-12-24 00:00:00'), 26.55, 'vsWSH', 'W37-20', '15', '46', '3.1', '1', '9', '2', '2', '12', '6.0', '0', '6', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2022-12-15 00:00:00'), 26.52, '@SEA', 'W21-13', '26', '108', '4.2', '1', '23', '6', '8', '30', '5.0', '0', '11', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2022-12-11 00:00:00'), 26.51, 'vsTB', 'W35-7', '14', '119', '8.5', '1', '38', '2', '3', '34', '17.0', '1', '27', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2022-12-04 00:00:00'), 26.49, 'vsMIA', 'W33-17', '17', '66', '3.9', '0', '30', '8', '10', '80', '10.0', '1', '33', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2022-11-27 00:00:00'), 26.47, 'vsNO', 'W13-0', '11', '32', '2.9', '0', '9', '4', '6', '17', '4.3', '0', '9', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2022-11-21 00:00:00'), 26.46, 'vsARI', 'W38-10', '7', '39', '5.6', '0', '20', '7', '7', '67', '9.6', '0', '14', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2022-11-13 00:00:00'), 26.44, 'vsLAC', 'W22-16', '14', '38', '2.7', '1', '12', '4', '6', '39', '9.8', '0', '21', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2022-10-30 00:00:00'), 26.4, '@LAR', 'W31-14', '18', '94', '5.2', '1', '25', '8', '9', '55', '6.9', '1', '14', '1', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2022-10-23 00:00:00'), 26.38, 'vsKC', 'L44-23', '8', '38', '4.8', '0', '12', '2', '2', '24', '12.0', '0', '13', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2022-10-16 00:00:00'), 26.36, '@LAR', 'L24-10', '13', '69', '5.3', '0', '17', '7', '8', '89', '12.7', '0', '49', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2022-10-09 00:00:00'), 26.34, 'vsSF', 'L37-15', '14', '54', '3.9', '1', '19', '7', '12', '50', '7.1', '0', '12', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2022-10-02 00:00:00'), 26.32, 'vsARI', 'L26-16', '8', '27', '3.4', '0', '10', '9', '9', '81', '9.0', '1', '34', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2022-09-25 00:00:00'), 26.3, 'vsNO', 'W22-14', '25', '108', '4.3', '0', '18', '2', '4', '7', '3.5', '0', '8', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2022-09-18 00:00:00'), 26.28, '@NYG', 'L19-16', '15', '102', '6.8', '0', '49', '4', '5', '26', '6.5', '0', '10', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2022-09-11 00:00:00'), 26.26, 'vsCLE', 'L26-24', '10', '33', '3.3', '1', '9', '4', '5', '24', '6.0', '0', '21', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2023-12-31 00:00:00'), 27.57, '@WSH', 'W27-10', '14', '64', '4.6', '0', '13', '4', '5', '27', '6.8', '0', '12', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2023-12-25 00:00:00'), 27.55, 'vsBAL', 'L33-19', '14', '103', '7.4', '1', '39', '6', '10', '28', '4.7', '0', '12', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2023-12-17 00:00:00'), 27.53, '@ARI', 'W45-29', '18', '115', '6.4', '1', '26', '5', '5', '72', '14.4', '2', '41', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2023-12-10 00:00:00'), 27.51, 'vsSEA', 'W28-16', '16', '145', '9.1', '0', '72', '1', '1', '8', '8.0', '0', '8', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2023-12-03 00:00:00'), 27.49, '@PHI', 'W42-19', '17', '93', '5.5', '1', '16', '3', '4', '40', '13.3', '0', '33', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2023-11-23 00:00:00'), 27.46, '@SEA', 'W31-13', '19', '114', '6.0', '2', '27', '5', '6', '25', '5.0', '0', '14', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2023-11-19 00:00:00'), 27.45, 'vsTB', 'W27-14', '21', '78', '3.7', '0', '12', '5', '5', '25', '5.0', '1', '11', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2023-11-12 00:00:00'), 27.43, '@JAX', 'W34-3', '16', '95', '5.9', '0', '19', '6', '10', '47', '7.8', '0', '17', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2023-10-29 00:00:00'), 27.39, 'vsCIN', 'L31-17', '12', '54', '4.5', '1', '16', '6', '7', '64', '10.7', '1', '28', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2023-10-23 00:00:00'), 27.38, '@MIN', 'L22-17', '15', '45', '3.0', '1', '9', '3', '3', '51', '17.0', '1', '35', '1', '1', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2023-10-15 00:00:00'), 27.36, '@CLE', 'L19-17', '11', '43', '3.9', '0', '27', '3', '3', '9', '3.0', '1', '13', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2023-10-08 00:00:00'), 27.34, 'vsDAL', 'W42-10', '19', '51', '2.7', '1', '8', '2', '3', '27', '13.5', '0', '19', '1', '1', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2023-10-01 00:00:00'), 27.32, 'vsARI', 'W35-16', '20', '106', '5.3', '3', '18', '7', '8', '71', '10.1', '1', '13', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2023-09-21 00:00:00'), 27.29, 'vsNYG', 'W30-12', '18', '85', '4.7', '1', '12', '5', '5', '34', '6.8', '0', '17', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2023-09-17 00:00:00'), 27.28, '@LAR', 'W30-23', '20', '116', '5.8', '1', '51', '3', '3', '19', '6.3', '0', '9', '0', '0', '0', '0'],
                ['McCaffrey', 'Christian', pd.Timestamp('2023-09-10 00:00:00'), 27.26, '@PIT', 'W30-7', '22', '152', '6.9', '1', '65', '3', '5', '17', '5.7', '0', '7', '1', '0', '0', '0']]
        expected_cmc = pd.DataFrame(data, columns=['LAST', 'FIRST', 'GAME_DT', 'AGE', 'OPP', 'RESULT', 'CAR', 'RUSH_YDS', 'RUSH_AVG', 'RUSH_TD', 'RUSH_LNG', 'REC', 'TGTS', 'REC_YDS', 'REC_AVG', 'REC_TD', 'REC_LNG', 'FUM', 'LST', 'FF', 'KB'])
        expected_cmc = expected_cmc.sort_values(by='GAME_DT')
        expected_cmc = expected_cmc.reset_index(drop=True)

        self.assertTrue(actual_cmc.equals(expected_cmc))

    def test_justin_tucker(self):

        tucker = espn.Player('Justin', 'Tucker', 15683, 'K')
        
        for season in [2019, 2020, 2021, 2022, 2023]:
            tucker.Set_Season(season)
            tucker.Set_Game_Log()

        actual_tucker = tucker.Get_Game_Log()

        data = [['Tucker', 'Justin', pd.Timestamp('2019-12-29 00:00:00'), 30.1, 'vsPIT', 'W28-10', '0-0', '1-1', '0-0', '3-3', '0-0', '47', '100.0', '4-4', '39', '2-2', '14'],
                ['Tucker', 'Justin', pd.Timestamp('2019-12-22 00:00:00'), 30.08, '@CLE', 'W31-15', '0-0', '0-0', '1-1', '0-0', '0-0', '31', '100.0', '1-1', '31', '4-4', '7'],
                ['Tucker', 'Justin', pd.Timestamp('2019-12-12 00:00:00'), 30.06, 'vsNYJ', 'W42-21', '0-0', '0-0', '0-0', '0-0', '0-0', '0', '0.0', '0-0', '0', '4-5', '4'],
                ['Tucker', 'Justin', pd.Timestamp('2019-12-08 00:00:00'), 30.05, '@BUF', 'W24-17', '0-0', '0-0', '1-1', '0-0', '0-0', '36', '100.0', '1-1', '36', '3-3', '6'],
                ['Tucker', 'Justin', pd.Timestamp('2019-12-01 00:00:00'), 30.03, 'vsSF', 'W20-17', '0-0', '0-0', '1-1', '1-1', '0-0', '49', '100.0', '2-2', '40', '2-2', '8'],
                ['Tucker', 'Justin', pd.Timestamp('2019-11-25 00:00:00'), 30.01, '@LAR', 'W45-6', '0-0', '0-0', '1-1', '0-0', '0-0', '34', '100.0', '1-1', '34', '6-6', '9'],
                ['Tucker', 'Justin', pd.Timestamp('2019-11-17 00:00:00'), 29.99, 'vsHOU', 'W41-7', '0-0', '0-0', '1-1', '1-2', '0-0', '46', '66.7', '2-3', '40', '5-5', '11'],
                ['Tucker', 'Justin', pd.Timestamp('2019-11-10 00:00:00'), 29.97, '@CIN', 'W49-13', '0-0', '0-0', '0-0', '0-0', '0-0', '0', '0.0', '0-0', '0', '7-7', '7'],
                ['Tucker', 'Justin', pd.Timestamp('2019-11-03 00:00:00'), 29.95, 'vsNE', 'W37-20', '0-0', '0-0', '1-1', '0-0', '0-0', '39', '100.0', '1-1', '39', '4-5', '7'],
                ['Tucker', 'Justin', pd.Timestamp('2019-10-20 00:00:00'), 29.91, '@SEA', 'W30-16', '0-0', '3-3', '0-0', '0-0', '0-0', '28', '100.0', '3-3', '25', '3-3', '12'],
                ['Tucker', 'Justin', pd.Timestamp('2019-10-13 00:00:00'), 29.89, 'vsCIN', 'W23-17', '0-0', '1-1', '0-0', '2-2', '0-0', '49', '100.0', '3-3', '37', '2-2', '11'],
                ['Tucker', 'Justin', pd.Timestamp('2019-10-06 00:00:00'), 29.87, '@PIT', 'W26-23 OT', '0-0', '2-2', '0-0', '2-2', '0-0', '48', '100.0', '4-4', '37', '2-2', '14'],
                ['Tucker', 'Justin', pd.Timestamp('2019-09-29 00:00:00'), 29.85, 'vsCLE', 'L40-25', '0-0', '0-0', '0-0', '1-1', '0-0', '41', '100.0', '1-1', '41', '2-2', '5'],
                ['Tucker', 'Justin', pd.Timestamp('2019-09-22 00:00:00'), 29.84, '@KC', 'L33-28', '0-0', '0-0', '1-1', '0-0', '0-0', '39', '100.0', '1-1', '39', '1-1', '4'],
                ['Tucker', 'Justin', pd.Timestamp('2019-09-15 00:00:00'), 29.82, 'vsARI', 'W23-17', '0-0', '1-1', '1-1', '0-0', '1-1', '51', '100.0', '3-3', '37', '2-2', '11'],
                ['Tucker', 'Justin', pd.Timestamp('2019-09-08 00:00:00'), 29.8, '@MIA', 'W59-10', '0-0', '0-0', '1-1', '0-0', '0-0', '34', '100.0', '1-1', '34', '8-8', '11'],
                ['Tucker', 'Justin', pd.Timestamp('2021-01-03 00:00:00'), 31.12, '@CIN', 'W38-3', '0-0', '0-0', '1-1', '0-0', '0-0', '34', '100.0', '1-1', '34', '5-5', '8'],
                ['Tucker', 'Justin', pd.Timestamp('2020-12-27 00:00:00'), 31.1, 'vsNYG', 'W27-13', '0-0', '2-2', '0-0', '0-0', '0-0', '28', '100.0', '2-2', '24', '3-3', '9'],
                ['Tucker', 'Justin', pd.Timestamp('2020-12-20 00:00:00'), 31.08, 'vsJAX', 'W40-14', '0-0', '0-0', '0-0', '1-1', '0-1', '46', '50.0', '1-2', '46', '5-5', '8'],
                ['Tucker', 'Justin', pd.Timestamp('2020-12-14 00:00:00'), 31.06, '@CLE', 'W47-42', '0-0', '0-0', '0-0', '0-0', '1-1', '55', '100.0', '1-1', '55', '4-5', '7'],
                ['Tucker', 'Justin', pd.Timestamp('2020-12-08 00:00:00'), 31.05, 'vsDAL', 'W34-17', '0-0', '1-1', '1-2', '0-0', '0-0', '35', '66.7', '2-3', '28', '4-4', '10'],
                ['Tucker', 'Justin', pd.Timestamp('2020-12-02 00:00:00'), 31.03, '@PIT', 'L19-14', '0-0', '0-0', '0-0', '0-0', '0-0', '0', '0.0', '0-0', '0', '2-2', '2'],
                ['Tucker', 'Justin', pd.Timestamp('2020-11-22 00:00:00'), 31.0, 'vsTEN', 'L30-24 OT', '0-0', '2-2', '1-1', '0-0', '0-0', '30', '100.0', '3-3', '29', '1-1', '10'],
                ['Tucker', 'Justin', pd.Timestamp('2020-11-15 00:00:00'), 30.98, '@NE', 'L23-17', '0-0', '1-1', '0-0', '0-0', '0-0', '24', '100.0', '1-1', '24', '2-2', '5'],
                ['Tucker', 'Justin', pd.Timestamp('2020-11-08 00:00:00'), 30.96, '@IND', 'W24-10', '0-0', '0-0', '0-0', '1-1', '0-0', '48', '100.0', '1-1', '48', '3-3', '6'],
                ['Tucker', 'Justin', pd.Timestamp('2020-11-01 00:00:00'), 30.95, 'vsPIT', 'L28-24', '0-0', '0-0', '0-0', '0-0', '1-1', '51', '100.0', '1-1', '51', '3-3', '6'],
                ['Tucker', 'Justin', pd.Timestamp('2020-10-18 00:00:00'), 30.91, '@PHI', 'W30-28', '0-0', '0-0', '0-0', '2-2', '1-1', '55', '100.0', '3-3', '49', '3-3', '12'],
                ['Tucker', 'Justin', pd.Timestamp('2020-10-11 00:00:00'), 30.89, 'vsCIN', 'W27-3', '0-0', '0-0', '1-1', '1-1', '0-1', '46', '66.7', '2-3', '42', '3-3', '9'],
                ['Tucker', 'Justin', pd.Timestamp('2020-10-04 00:00:00'), 30.87, '@WSH', 'W31-17', '0-0', '0-0', '0-0', '1-1', '0-0', '46', '100.0', '1-1', '46', '4-4', '7'],
                ['Tucker', 'Justin', pd.Timestamp('2020-09-28 00:00:00'), 30.85, 'vsKC', 'L34-20', '0-0', '1-1', '0-0', '1-1', '0-0', '42', '100.0', '2-2', '34', '2-2', '8'],
                ['Tucker', 'Justin', pd.Timestamp('2020-09-20 00:00:00'), 30.83, '@HOU', 'W33-16', '0-0', '1-1', '2-2', '1-1', '0-0', '47', '100.0', '4-4', '34', '3-3', '15'],
                ['Tucker', 'Justin', pd.Timestamp('2020-09-13 00:00:00'), 30.81, 'vsCLE', 'W38-6', '0-0', '0-0', '0-0', '1-1', '0-0', '41', '100.0', '1-1', '41', '5-5', '8'],
                ['Tucker', 'Justin', pd.Timestamp('2022-01-09 00:00:00'), 32.13, 'vsPIT', 'L16-13 OT', '0-0', '1-1', '0-0', '1-1', '0-0', '46', '100.0', '2-2', '35', '1-1', '7'],
                ['Tucker', 'Justin', pd.Timestamp('2022-01-02 00:00:00'), 32.12, 'vsLAR', 'L20-19', '0-0', '1-1', '1-1', '2-2', '0-0', '46', '100.0', '4-4', '37', '1-1', '13'],
                ['Tucker', 'Justin', pd.Timestamp('2021-12-26 00:00:00'), 32.1, '@CIN', 'L41-21', '0-0', '0-0', '0-0', '0-0', '0-0', '0', '0.0', '0-0', '0', '3-3', '3'],
                ['Tucker', 'Justin', pd.Timestamp('2021-12-19 00:00:00'), 32.08, 'vsGB', 'L31-30', '0-0', '0-0', '1-1', '0-0', '0-0', '38', '100.0', '1-1', '38', '3-3', '6'],
                ['Tucker', 'Justin', pd.Timestamp('2021-12-12 00:00:00'), 32.06, '@CLE', 'L24-22', '0-0', '0-0', '0-0', '1-1', '2-2', '55', '100.0', '3-3', '49', '1-1', '10'],
                ['Tucker', 'Justin', pd.Timestamp('2021-12-05 00:00:00'), 32.04, '@PIT', 'L20-19', '0-0', '1-1', '1-1', '0-0', '0-0', '35', '100.0', '2-2', '32', '1-1', '7'],
                ['Tucker', 'Justin', pd.Timestamp('2021-11-28 00:00:00'), 32.02, 'vsCLE', 'W16-10', '0-0', '1-1', '0-0', '1-1', '1-1', '52', '100.0', '3-3', '42', '1-1', '10'],
                ['Tucker', 'Justin', pd.Timestamp('2021-11-21 00:00:00'), 32.0, '@CHI', 'W16-13', '0-0', '1-1', '1-1', '1-1', '0-0', '46', '100.0', '3-3', '36', '1-1', '10'],
                ['Tucker', 'Justin', pd.Timestamp('2021-11-11 00:00:00'), 31.97, '@MIA', 'L22-10', '0-0', '0-0', '0-0', '1-2', '0-0', '46', '50.0', '1-2', '46', '1-1', '4'],
                ['Tucker', 'Justin', pd.Timestamp('2021-11-07 00:00:00'), 31.96, 'vsMIN', 'W34-31 OT', '0-0', '0-0', '2-2', '0-0', '0-0', '37', '100.0', '2-2', '36', '4-4', '10'],
                ['Tucker', 'Justin', pd.Timestamp('2021-10-24 00:00:00'), 31.92, 'vsCIN', 'L41-17', '0-0', '0-0', '0-0', '1-1', '0-0', '45', '100.0', '1-1', '45', '2-2', '5'],
                ['Tucker', 'Justin', pd.Timestamp('2021-10-17 00:00:00'), 31.9, 'vsLAC', 'W34-6', '0-0', '0-0', '1-1', '0-0', '1-1', '52', '100.0', '2-2', '46', '4-4', '10'],
                ['Tucker', 'Justin', pd.Timestamp('2021-10-11 00:00:00'), 31.89, 'vsIND', 'W31-25 OT', '0-0', '1-1', '0-0', '0-0', '0-0', '23', '100.0', '1-1', '23', '0-0', '3'],
                ['Tucker', 'Justin', pd.Timestamp('2021-10-03 00:00:00'), 31.87, '@DEN', 'W23-7', '0-0', '1-1', '0-0', '2-2', '0-0', '46', '100.0', '3-3', '35', '2-2', '11'],
                ['Tucker', 'Justin', pd.Timestamp('2021-09-26 00:00:00'), 31.85, '@DET', 'W19-17', '0-0', '0-0', '2-2', '0-1', '2-2', '66', '80.0', '4-5', '47', '1-1', '13'],
                ['Tucker', 'Justin', pd.Timestamp('2021-09-19 00:00:00'), 31.83, 'vsKC', 'W36-35', '0-0', '0-0', '0-0', '1-1', '0-0', '43', '100.0', '1-1', '43', '3-3', '6'],
                ['Tucker', 'Justin', pd.Timestamp('2021-09-13 00:00:00'), 31.81, '@LV', 'L33-27 OT', '0-0', '0-0', '0-0', '2-2', '0-0', '47', '100.0', '2-2', '44', '3-3', '9'],
                ['Tucker', 'Justin', pd.Timestamp('2023-01-08 00:00:00'), 33.13, '@CIN', 'L27-16', '0-0', '2-2', '0-0', '0-0', '1-1', '51', '100.0', '3-3', '35', '1-1', '10'],
                ['Tucker', 'Justin', pd.Timestamp('2023-01-01 00:00:00'), 33.11, 'vsPIT', 'L16-13', '0-0', '0-0', '1-1', '0-0', '1-1', '51', '100.0', '2-2', '40', '1-1', '7'],
                ['Tucker', 'Justin', pd.Timestamp('2022-12-24 00:00:00'), 33.09, 'vsATL', 'W17-9', '0-0', '3-3', '0-0', '0-0', '0-1', '27', '75.0', '3-4', '23', '0-0', '9'],
                ['Tucker', 'Justin', pd.Timestamp('2022-12-17 00:00:00'), 33.07, '@CLE', 'L13-3', '0-0', '0-0', '0-0', '0-1', '1-2', '53', '33.0', '1-3', '53', '0-0', '3'],
                ['Tucker', 'Justin', pd.Timestamp('2022-12-11 00:00:00'), 33.05, '@PIT', 'W16-14', '0-0', '0-0', '2-2', '1-1', '0-0', '42', '100.0', '3-3', '36', '1-1', '10'],
                ['Tucker', 'Justin', pd.Timestamp('2022-12-04 00:00:00'), 33.04, 'vsDEN', 'W10-9', '0-0', '1-1', '0-0', '0-0', '0-0', '26', '100.0', '1-1', '26', '1-1', '4'],
                ['Tucker', 'Justin', pd.Timestamp('2022-11-27 00:00:00'), 33.02, '@JAX', 'L28-27', '0-0', '3-3', '0-0', '0-0', '1-2', '55', '80.0', '4-5', '34', '1-1', '13'],
                ['Tucker', 'Justin', pd.Timestamp('2022-11-20 00:00:00'), 33.0, 'vsCAR', 'W13-3', '0-0', '0-0', '2-2', '0-0', '0-0', '37', '100.0', '2-2', '34', '1-1', '7'],
                ['Tucker', 'Justin', pd.Timestamp('2022-11-07 00:00:00'), 32.96, '@NO', 'W27-13', '0-0', '0-0', '1-1', '1-1', '0-0', '41', '100.0', '2-2', '36', '3-3', '9'],
                ['Tucker', 'Justin', pd.Timestamp('2022-10-27 00:00:00'), 32.93, '@TB', 'W27-22', '0-0', '1-1', '1-1', '0-0', '0-1', '30', '67.0', '2-3', '26', '3-3', '9'],
                ['Tucker', 'Justin', pd.Timestamp('2022-10-23 00:00:00'), 32.92, 'vsCLE', 'W23-20', '0-0', '0-0', '2-2', '0-0', '1-1', '55', '100.0', '3-3', '40', '2-2', '11'],
                ['Tucker', 'Justin', pd.Timestamp('2022-10-16 00:00:00'), 32.9, '@NYG', 'L24-20', '0-0', '1-1', '1-1', '0-0', '0-1', '34', '67.0', '2-3', '28', '2-2', '8'],
                ['Tucker', 'Justin', pd.Timestamp('2022-10-09 00:00:00'), 32.88, 'vsCIN', 'W19-17', '0-0', '1-1', '1-1', '1-1', '1-1', '58', '100.0', '4-4', '41', '1-1', '13'],
                ['Tucker', 'Justin', pd.Timestamp('2022-10-02 00:00:00'), 32.86, 'vsBUF', 'L23-20', '0-0', '0-0', '0-0', '1-1', '1-1', '51', '100.0', '2-2', '46', '2-2', '8'],
                ['Tucker', 'Justin', pd.Timestamp('2022-09-25 00:00:00'), 32.84, '@NE', 'W37-26', '0-0', '0-0', '0-0', '0-0', '1-1', '56', '100.0', '1-1', '56', '4-5', '7'],
                ['Tucker', 'Justin', pd.Timestamp('2022-09-18 00:00:00'), 32.82, 'vsMIA', 'L42-38', '0-0', '0-0', '0-0', '0-0', '1-1', '51', '100.0', '1-1', '51', '5-5', '8'],
                ['Tucker', 'Justin', pd.Timestamp('2022-09-11 00:00:00'), 32.81, '@NYJ', 'W24-9', '0-0', '1-1', '0-0', '0-0', '0-0', '24', '100.0', '1-1', '24', '3-3', '6'],
                ['Tucker', 'Justin', pd.Timestamp('2024-01-06 00:00:00'), 34.12, 'vsPIT', 'L17-10', '0-0', '0-0', '1-1', '0-0', '0-0', '36', '100.0', '1-1', '36', '1-1', '4'],
                ['Tucker', 'Justin', pd.Timestamp('2023-12-31 00:00:00'), 34.11, 'vsMIA', 'W56-19', '0-0', '0-0', '0-0', '0-0', '0-0', '0', '0.0', '0-0', '0', '8-8', '8'],
                ['Tucker', 'Justin', pd.Timestamp('2023-12-25 00:00:00'), 34.09, '@SF', 'W33-19', '0-0', '3-3', '0-0', '1-1', '0-0', '41', '100.0', '4-4', '30', '3-3', '15'],
                ['Tucker', 'Justin', pd.Timestamp('2023-12-17 00:00:00'), 34.07, '@JAX', 'W23-7', '0-0', '1-1', '1-1', '1-1', '0-0', '43', '100.0', '3-3', '34', '2-2', '11'],
                ['Tucker', 'Justin', pd.Timestamp('2023-12-10 00:00:00'), 34.05, 'vsLAR', 'W37-31 OT', '0-0', '0-0', '2-2', '1-1', '0-0', '47', '100.0', '3-3', '37', '2-2', '11'],
                ['Tucker', 'Justin', pd.Timestamp('2023-11-26 00:00:00'), 34.01, '@LAC', 'W20-10', '0-0', '0-0', '0-0', '2-3', '0-0', '48', '67.0', '2-3', '45', '2-2', '8'],
                ['Tucker', 'Justin', pd.Timestamp('2023-11-16 00:00:00'), 33.99, 'vsCIN', 'W34-20', '0-0', '1-1', '0-0', '1-1', '0-0', '47', '100.0', '2-2', '36', '4-4', '10'],
                ['Tucker', 'Justin', pd.Timestamp('2023-11-12 00:00:00'), 33.98, 'vsCLE', 'L33-31', '0-0', '0-0', '1-1', '0-0', '0-1', '37', '50.0', '1-2', '37', '4-4', '7'],
                ['Tucker', 'Justin', pd.Timestamp('2023-11-05 00:00:00'), 33.96, 'vsSEA', 'W37-3', '0-0', '0-0', '2-2', '1-1', '0-0', '45', '100.0', '3-3', '38', '4-4', '13'],
                ['Tucker', 'Justin', pd.Timestamp('2023-10-29 00:00:00'), 33.94, '@ARI', 'W31-24', '0-0', '0-0', '0-0', '1-1', '0-1', '48', '50.0', '1-2', '48', '4-4', '7'],
                ['Tucker', 'Justin', pd.Timestamp('2023-10-22 00:00:00'), 33.92, 'vsDET', 'W38-6', '0-0', '0-0', '1-1', '0-0', '0-0', '32', '100.0', '1-1', '32', '5-5', '8'],
                ['Tucker', 'Justin', pd.Timestamp('2023-10-15 00:00:00'), 33.9, 'vsTEN', 'W24-16', '0-0', '4-4', '1-1', '1-1', '0-0', '41', '100.0', '6-6', '30', '0-1', '18'],
                ['Tucker', 'Justin', pd.Timestamp('2023-10-08 00:00:00'), 33.88, '@PIT', 'L17-10', '0-0', '1-1', '0-0', '0-0', '0-0', '23', '100.0', '1-1', '23', '1-1', '4'],
                ['Tucker', 'Justin', pd.Timestamp('2023-10-01 00:00:00'), 33.86, '@CLE', 'W28-3', '0-0', '0-0', '0-0', '0-0', '0-0', '0', '0.0', '0-0', '0', '4-4', '4'],
                ['Tucker', 'Justin', pd.Timestamp('2023-09-24 00:00:00'), 33.84, 'vsIND', 'L22-19 OT', '0-0', '0-0', '0-0', '0-0', '1-2', '50', '50.0', '1-2', '50', '2-2', '5'],
                ['Tucker', 'Justin', pd.Timestamp('2023-09-17 00:00:00'), 33.82, '@CIN', 'W27-24', '0-0', '0-0', '0-0', '2-2', '0-1', '44', '67.0', '2-3', '42', '3-3', '9'],
                ['Tucker', 'Justin', pd.Timestamp('2023-09-10 00:00:00'), 33.8, 'vsHOU', 'W25-9', '0-0', '0-0', '1-1', '0-0', '0-0', '39', '100.0', '1-1', '39', '2-2', '5']]
        expected_tucker = pd.DataFrame(data, columns=['LAST', 'FIRST', 'GAME_DT', 'AGE', 'OPP', 'RESULT', '1-19', '20-29', '30-39', '40-49', '50+', 'LNG', 'FG%', 'FG', 'AVG', 'XP', 'PTS'])
        expected_tucker = expected_tucker.sort_values(by='GAME_DT')
        expected_tucker = expected_tucker.reset_index(drop=True)

        self.assertTrue(actual_tucker.equals(expected_tucker))

    def test_age_calc(self):
        
        actual = calculate_age(pd.Timestamp('1997-02-10 00:00:00'), pd.Timestamp('2024-09-01 00:00:00'))

        self.assertEqual(actual, 27.56)

    def verify_espn_pull(self, df, firstName, lastName):

        for item in df['LAST']: self.assertTrue(item == lastName)
        
        for item in df['FIRST']: self.assertTrue(item == firstName)

        for item in df['GAME_DT']:
            self.assertTrue(isinstance(item, pd.Timestamp))

        last_age = 0
        for item in df['AGE']:
            self.assertTrue(item > 19)         # Youngest NFL Player
            self.assertTrue(item < 46)         # Oldest NFL Player
            self.assertTrue(item >= last_age)   # Ascending Age
            last_age = item

        for item in df['OPP']:
            self.assertTrue(item[0] == '@' or item[:2] == 'vs')
            self.assertFalse(item.isnumeric())

        for item in df['RESULT']:
            self.assertTrue(item[0] == 'W' or item[0] == 'L' or item[0] == 'T')

    def verify_quarterback(self, df, firstName, lastName):

        self.test_espn(df, firstName, lastName)

        numeric_stats = ['CMP', 'ATT', 'PASS_YDS', 'PASS_TD', 'INT', 'PASS_LNG', 'SACK', 'CAR', 'RUSH_YDS', 'RUSH_TD', 'RUSH_LNG']
        for stat in numeric_stats:
            for item in df[stat]:
                self.assertTrue(item.isnumeric() or item[1:].isnumeric())

        numeric_stats = ['CMP%', 'PASS_AVG', 'RTG', 'QBR', 'RUSH_AVG']
        for stat in numeric_stats:
            for item in df[stat]:
                self.assertTrue(item[0].isnumeric() or item[1].isnumeric())
                
    def verify_flex(self, df, firstName, lastName):

        self.test_espn(df, firstName, lastName)

        numeric_stats = ['CAR', 'RUSH_YDS', 'RUSH_TD', 'RUSH_LNG', 'REC', 'TGTS', 'REC_YDS', 'REC_TD', 'REC_LNG', 'FUM', 'LST', 'FF', 'KB']
        for stat in numeric_stats:
            for item in df[stat]:
                self.assertTrue(item.isnumeric() or item[1:].isnumeric())

        numeric_stats = ['RUSH_AVG', 'REC_AVG']
        for stat in numeric_stats:
            for item in df[stat]:
                self.assertTrue(item[0].isnumeric() or item[1].isnumeric())

    def verify_kicker(self, df, firstName, lastName):

        self.test_espn(df, firstName, lastName)

        dist_stats = ['1-19', '20-29', '30-39', '40-49', '50+', 'FG', 'XP']
        for stat in dist_stats:
            for item in df[stat]:
                self.assertTrue(item[0].isnumeric())
                self.assertTrue((item[1] == '-' and item[2].isnumeric()) or 
                                (item[2] == '-' and item[3].isnumeric() and item[4].isnumeric()))

        numeric_stats = ['LNG', 'AVG', 'PTS']
        for stat in numeric_stats:
            for item in df[stat]:
                self.assertTrue(item.isnumeric())
        
        for item in df['FG%']:
            self.assertTrue(item[0].isnumeric() and item[-1].isnumeric() and item[-2] == '.')

if __name__ == '__main__':

    unittest.main()

